#include "ui_mainwindow.h"
#include "mainwindow.h"
#include "qdebug.h"

void MainWindow::detect_object( QColor rgb_temp, uint16_t x, uint16_t y ){

        if ( rgb_temp.black() ) {
            if( x > xmax ) xmax = x;
            if( x < xmin ) xmin = x;
            if( y > ymax ) ymax = y;
            if( y < ymin ) ymin = y;
            black_pixel_count++;
        }

        if ( !rgb_temp.black() ) {
            white_pixel_count++;
        }


}

void MainWindow::finger_detect(){
#define finger_detect_line   0.2*(ymax-ymin)+ymin

    if ( k < 0.6 && k > 0.3 ){
        scene_3->addLine( 2*xmin, 2*(finger_detect_line ), 2*xmax, 2*(finger_detect_line), outlinePen_red );
        finger = 0;
        bool lock = false;
        for ( int temp_x = 2*xmin; temp_x <= 2*xmax; temp_x++ ){
            if ( lock == false and image_3.pixelColor( temp_x, 2*(finger_detect_line) ).black() ){
                lock = true;
                finger++;

            }
            if( lock == true and !image_3.pixelColor( temp_x, 2*(finger_detect_line) ).black() ){
                lock = false;
            }
        }
        detected_gesture = finger;
    }else{
        finger = 0;
    }
}

void MainWindow::fist_detect(){

    if ( k > 0.6 && k < 1.1 && b_to_w < 0.5 && b_to_w > 0.1){
        detected_gesture = 3;
    }
}

void MainWindow::thumb_rotate_detect(){
#define thumb_rotate_detect_line_l   xmin + 0.3*(xmax-xmin)
#define thumb_rotate_detect_line_r   xmax - 0.3*(xmax-xmin)
uint8_t temp_count_black_l = 0, temp_count_black_r = 0;
    if ( k > 1.2 && k < 1.4 && b_to_w < 0.4 && b_to_w > 0.1){
        scene_3->addLine( 2*thumb_rotate_detect_line_l, 2*ymin, 2*thumb_rotate_detect_line_l, 2*ymax, outlinePen_red );
        scene_3->addLine( 2*thumb_rotate_detect_line_r, 2*ymin, 2*thumb_rotate_detect_line_r, 2*ymax, outlinePen_red );

        for ( int temp_y_l = 2*ymin; temp_y_l <= 2*ymax; temp_y_l++ ){
            ( image_3.pixelColor( 2*(thumb_rotate_detect_line_l), temp_y_l ).black() ) ?  temp_count_black_l++ : temp_count_black_l ;
        }
        for ( int temp_y_r = 2*ymin; temp_y_r <= 2*ymax; temp_y_r   ++ ){
            ( image_3.pixelColor( 2*(thumb_rotate_detect_line_r), temp_y_r ).black() ) ? temp_count_black_r++ : temp_count_black_r;
        }

        temp_count_black_l > temp_count_black_r ? detected_gesture = 4 : detected_gesture = 5;
    }

}


void MainWindow::display_info_detection(){
    white_pixel_count ? b_to_w = (double)(black_pixel_count) / (double)(white_pixel_count) : b_to_w = 0 ;
    ( (ymax - ymin) != 0 ) ? k = (double)(xmax - xmin) / (double)(ymax - ymin) : k = 0;

    ui->detect_object_label->setText( "Black pixel: " + QString::number(black_pixel_count) + "\n" +
                                      "White pixel: " + QString::number(white_pixel_count) + "\n" +
                                      "Finger(s): " + QString::number(finger) + "\n" +
                                      "Detected gesture: " + QString::number(detected_gesture) + "\n" +
                                      "b_to_w: " + QString::number(b_to_w) + "\n" +
                                      "w_to_h: " + QString::number(k) );
}
