#include "ui_mainwindow.h"
#include "mainwindow.h"
#include "qdebug.h"

void MainWindow::rgb_correct( QColor rgb_temp ){
//qDebug() << (QString("rgb_value: R: %1, G: %2, B: %3").arg(rgb_current.red()).arg(rgb_current.green()).arg(rgb_current.blue()));

    if ( rgb_temp.red() + correction_red < 256 and rgb_temp.red() + correction_red > -1) {
        rgb_temp.setRed(rgb_temp.red() + correction_red);
    }else if ( rgb_temp.red() + correction_red < 0){
        rgb_temp.setRed(0);
    }else{
        rgb_temp.setRed(255);
    }

    if ( rgb_temp.green() + correction_green < 256 and rgb_temp.green() + correction_green > -1 ) {
        rgb_temp.setGreen(rgb_temp.green() + correction_green);
    }else if ( rgb_temp.green() + correction_green < 0){
        rgb_temp.setGreen(0);
    }else{
        rgb_temp.setGreen(255);
    }

    if ( rgb_temp.blue() + correction_blue < 256 and rgb_temp.blue() + correction_blue > -1 ) {
        rgb_temp.setBlue(rgb_temp.blue() + correction_blue);
    }else if ( rgb_temp.blue() + correction_blue < 0){
        rgb_temp.setBlue(0);
    }else{
        rgb_temp.setBlue(255);
    }

    rgb_current = rgb_temp;
//qDebug() << (QString("rgb_value: R: %1, G: %2, B: %3").arg(rgb_current.red()).arg(rgb_current.green()).arg(rgb_current.blue()));
}

void MainWindow::rgb_mono( QColor rgb_temp ){
    uint16_t mono_color_temp = 0;

    mono_color_temp = ( rgb_temp.red() +  rgb_temp.green() + rgb_temp.blue() ) / 3;

    rgb_current.setRgb( mono_color_temp, mono_color_temp, mono_color_temp );
}

void MainWindow::thresholding( QColor rgb_temp ){

    uint16_t mono_color_temp = 0;

    mono_color_temp = ( rgb_temp.red() +  rgb_temp.green() + rgb_temp.blue() ) / 3;

    if ( !ui->real->isChecked() and ui->reverse->isChecked() ){
        (ui->thresholding_value->value() <= mono_color_temp ) ? rgb_temp.setRgb( 0, 0, 0 ): rgb_temp.setRgb( 255, 255, 255 );
    }

    if ( !ui->real->isChecked() and !ui->reverse->isChecked() ){
        (ui->thresholding_value->value() <= mono_color_temp ) ? rgb_temp.setRgb( 255, 255, 255 ): rgb_temp.setRgb( 0, 0, 0 );
    }

    if ( ui->real->isChecked() and ui->reverse->isChecked() and ui->thresholding_value->value() <= mono_color_temp ){
        rgb_temp.setRgb( 0, 0, 0 );
    }

    if ( ui->real->isChecked() and !ui->reverse->isChecked() and ui->thresholding_value->value() > mono_color_temp ){
        rgb_temp.setRgb( 0, 0, 0 );
    }

    rgb_current = rgb_temp;
}

void MainWindow::brightness( QColor rgb_temp ){



    if ( rgb_temp.red() + correction_brightness < 256 and rgb_temp.red() + correction_brightness > -1) {
        rgb_temp.setRed(rgb_temp.red() + correction_brightness);
    }else if ( rgb_temp.red() + correction_brightness < 0){
        rgb_temp.setRed(0);
    }else{
        rgb_temp.setRed(255);
    }

    if ( rgb_temp.green() + correction_brightness < 256 and rgb_temp.green() + correction_brightness > -1 ) {
        rgb_temp.setGreen(rgb_temp.green() + correction_brightness);
    }else if ( rgb_temp.green() + correction_brightness < 0){
        rgb_temp.setGreen(0);
    }else{
        rgb_temp.setGreen(255);
    }

    if ( rgb_temp.blue() + correction_brightness < 256 and rgb_temp.blue() + correction_brightness > -1 ) {
        rgb_temp.setBlue(rgb_temp.blue() + correction_brightness);
    }else if ( rgb_temp.blue() + correction_brightness < 0){
        rgb_temp.setBlue(0);
    }else{
        rgb_temp.setBlue(255);
    }


    rgb_current = rgb_temp;

}

void MainWindow::lut( QColor rgb_temp ){
    //clear LUT array
    for ( int i = 0; i<256; i++ ){
        LUT[ i ] = 0;
    }

    if (ui->lut->isChecked() and ui->negative->isChecked()){
        for ( int i = 0; i<256; i++){
            LUT[ i ] = 255 - i;
        }
    }

    if (ui->lut->isChecked() and ui->contrast->isChecked()){
        int k = 0;
        k = ui->correction_contrast->value();

        for ( int i = 0; i<256; i++){
            if (i <= k ) LUT[i] = 0;
            if (i >= 255 - k) LUT[i] = 255;
            if (((255 / ((255 - k) - k)) * i - (255 / ((255 - k) - k)) * k <= 255 ) and
               ((255 / ((255 - k) - k)) * i - (255 / ((255 - k) - k)) * k >= 0) and
               (i > k) and (i < 255 - k)) {
               LUT[i] = (255 / ((255 - k) - k)) * i - (255 / ((255 - k) - k)) * k;
            }
        }

    }




    rgb_temp.setRed( LUT[ rgb_temp.red() ] );
    rgb_temp.setGreen( LUT[ rgb_temp.green() ] );
    rgb_temp.setBlue( LUT[ rgb_temp.blue() ] );
    rgb_current = rgb_temp;
}

