#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QCameraViewfinder>
#include <QGraphicsScene>
#include <QVector>

#include <QTcpSocket>
#include <QAbstractSocket>
#include <QProcess>

#define array_size  94


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    /***New variable***/
    QColor rgb_real, rgb_filtr, rgb_temp, rgb_current;
    QPoint mouse_curosr_position;
    int x, y;
    QString style_statusBar;
    uint16_t x1 = 200, x2 = 300, y1 = 20, y2 = 120;
    uint16_t LUT [255];
    bool tcp_connect = false;
    /***New variable***/

private slots:
    /***New function***/
    void get_image_from_frame( uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2 );
    void send_to_array( QColor rgb_temp );
    void draw_zoom_pixel( uint16_t x, uint16_t y, QColor rgb_temp );
    void draw_char( uint8_t red_array[], uint8_t green_array[], uint8_t blue_array[] );
    void get_image_from_point( int x, int y );
    void draw_cursor( int x, int y ); 
    void thresholding( QColor rgb_temp );
    void rgb_correct( QColor rgb_temp );
    void rgb_mono( QColor rgb_temp);
    void brightness( QColor rgb_temp );
    void lut( QColor rgb_temp );
    void detect_object( QColor rgb_temp, uint16_t x, uint16_t y );
    void finger_detect();
    void display_info_detection();
    void thumb_rotate_detect();
    void fist_detect();
    /***New function***/
    void start();
    void doConnect();
    void connected();
    void disconnected();
    void RGB_from_point();
    void send_tcp_value();

    void on_spinBox_valueChanged(int arg1);

    void on_start_stop_clicked(bool checked);

    void on_clear_memory_clicked();

    void on_correction_red_valueChanged(int arg1);

    void on_correction_green_valueChanged(int arg1);

    void on_correction_blue_valueChanged(int arg1);

    void on_set_y2_valueChanged(int arg1);

    void on_set_x2_valueChanged(int arg1);

    void on_set_y1_valueChanged(int arg1);

    void on_set_x1_valueChanged(int arg1);

    void on_correction_brightness_valueChanged(int arg1);

    void on_pushButton_2_clicked();

    void on_pushButton_clicked();


    void on_connect_tcp_clicked();




private:
    Ui::MainWindow *ui;
    QTcpSocket *socket;
    QCameraViewfinder *viewfinder;
    QGraphicsScene *scene;
    QGraphicsScene *scene_2;
    QGraphicsScene *scene_3;
    QGraphicsScene *scene_4;
    QPixmap pixmap_1, pixmap_3;
    QImage image_3;
    uint32_t d_x = 10;
    uint8_t bufor_red, bufor_green, bufor_blue;
    QTimer *timer1;
    QTimer *timer2;
    uint8_t red_array[array_size];
    uint8_t green_array[array_size];
    uint8_t blue_array[array_size];
    uint8_t scale;
    QColor rgbvalue;//, rgb_temp;
    QColor *current_rgb_temp;
    QPen outlinePen_red, outlinePen_black, outlinePen_green, outlinePen_blue, outlinePen_cursor;
    int16_t correction_red = 0, correction_green = 0, correction_blue = 0, correction_brightness = 0;
    uint16_t max_x_w = 225, max_y_h = 150, min_x_w = 125, min_y_h = 50;
    uint16_t xmin = 500, xmax = 0, ymin = 500, ymax = 0, black_pixel_count = 0, white_pixel_count = 0;    //detect object
    double k = 0, b_to_w = 0;
    uint8_t finger = '0';
    uint8_t detected_gesture = 0;
};


#endif // MAINWINDOW_H
